"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const internals_1 = require("../internals");
/**
 * Returns a copy of a tree, preserving the mutable/immutable status of the input tree.
 *
 * @export
 * @template K The type of keys in the tree
 * @template V The type of values in the tree
 * @param {RedBlackTreeStructure<K, V>} tree The tree to be cloned
 * @returns {RedBlackTreeStructure<K, V>} A cloned instance of the input tree
 */
function clone(tree, mutability) {
    return internals_1.cloneTree(tree, mutability);
}
exports.clone = clone;

//# sourceMappingURL=clone.js.map
