import { rotateLeft, rotateRight, rotateLeftRight, rotateRightLeft, updateCount } from './ops';
import { PathNode } from './path';
import { editLeftChild, editRightChild, } from './node';
export function rebalance(tail, node, parent, tree) {
    var p = tail;
    var done = false;
    do {
        parent = p.node;
        if (done) {
            updateCount(parent);
        }
        else if (parent._red) {
            var pp = p.parent, grandParent = pp.node;
            var uncle = pp.next === 1 /* LEFT */ ? editRightChild(tree, grandParent) : editLeftChild(tree, grandParent);
            if (uncle._red) {
                uncle._red = false;
                parent._red = false;
                if (pp.parent.isActive()) {
                    grandParent._red = true;
                }
                updateCount(parent);
                updateCount(grandParent);
                node = grandParent;
            }
            else {
                if (pp.next === p.next) {
                    if (p.next === 1 /* LEFT */) {
                        rotateRight(pp.parent, grandParent, parent, tree);
                    }
                    else {
                        rotateLeft(pp.parent, grandParent, parent, tree);
                    }
                    grandParent._red = true;
                    parent._red = false;
                    node = parent;
                }
                else {
                    if (p.next === 1 /* LEFT */) {
                        rotateRightLeft(pp.parent, grandParent, parent, node, tree);
                    }
                    else {
                        rotateLeftRight(pp.parent, grandParent, parent, node, tree);
                    }
                    node._red = false;
                    grandParent._red = true;
                }
            }
            p = p.release();
            if (!node._red) {
                done = true;
            }
        }
        else {
            done = parent === p.node;
            node = parent;
            updateCount(node);
        }
        p = p.release();
    } while (p.isActive());
    if (p.isActive()) {
        node = PathNode.release(p, node);
    }
}

//# sourceMappingURL=rebalance.js.map
